18.04.2021

Автор CUPS выпустил PAPPL 1.0, фреймворк для организации вывода на печать


Майкл Свит (Michael R Sweet), изначальный автор системы печати CUPS, который после увольнения из компании Apple переключился на разработку форка CUPS от проекта OpenPrinting, представил первый стабильный выпуск PAPPL, нового фреймворка для разработки приложений для печати (CUPS Printer Applications) на базе протокола IPP Everywhere, которые рекомендуется использовать в качестве замены традиционным драйверам для принтеров. Код фреймворка написан на языке Си и распространяется под лицензией Apache 2.0 с исключением, разрешающим связывание с кодом под лицензиями GPLv2 и LGPLv2.

Фреймворк изначально разработан для поддержки системы печати LPrint и драйверов Gutenprint, но может быть использован для реализации поддержки любых принтеров и драйверов при выводе на печать на настольных, серверных и встраиваемых системах. Предполагается, что PAPPL сможет способствовать ускорению продвижения технологии IPP Everywhere вместо классических драйверов и упрощению поддержки других программ на основе IPP, таких как AirPrint и Mopria.

PAPPL включает встроенную реализацию протокола IPP Everywhere, предоставляющего средства для доступа к принтерам локально или по сети и обработки запросов по выводу на печать. IPP Everywhere работает в бездрайверном режиме («driverless») и в отличие от драйверов PPD не требует создания статических файлов конфигурации. Поддерживается взаимодействие с принтерами как напрямую через локальное подключение принтера по USB, так и обращение по сети при помощи протоколов AppSocket и JetDirect. Данные могут отправляться на принтер в форматах JPEG, PNG, PWG Raster, Apple Raster и «raw».

PAPPL может быть собран для POSIX-совместимых ОС, включая Linux, macOS, QNX и VxWorks. Из зависимостей отмечается Avahi 0.8 (для поддержки mDNS/DNS-SD), CUPS 2.2, GNU TLS 3.0, JPEGLIB 9, LIBPNG 1.6, LIBPAM (для аутентификации) и ZLIB 1.1. На базе PAPPL проектом OpenPrinting развивается универсальное приложение PostScript Printer Application, способное работать как с современными IPP-совместимыми принтерами (используется PAPPL), поддерживающими PostScript и Ghostscript, так и со старыми принтерами, для которых имеются драйверы PPD (применяются фильтры cups-filters и libppd).

Источник: https://www.opennet.ru/opennews/art.shtml?num=54245

Добавить комментарий